/*****************************************************************
* ̧: flashStorageDriver.c
*
* łƓt:
*       1.0: 2002N1104 JLL
*       1.1: 2002N1121 JLL
*       1.2: 2003N0703 RAA
*
* : JLL
*
* e:
*        {̧قׯɕۑꂽ璷ްQ̒`܂܂BړIEEPROMނ
*        ׯ ؂Ұۑ邱ƂłB۸ݸނ̎gpɂҰ
*        XVł܂B̗Ľ\ɂ邽߂ɏ璷Iɕۑ܂B
*        s錟́Aʒu0ł邱(0)A璷SĊmF
*        ƁAްQɕۑꂽтƂ𒲍܂Bǂꂩ̌
*        s̏ꍇُ͈үނԂ܂B
*
*        ̗0䌟Ə璷̌Uُ͉񕜂ł܂B
*        肪ׯݻق̑Î߂Ƃ̉ŁAްAND邱Ƃɂ
*        s܂BڍׂɂĂ͉pLqQƂĂB
*
*****************************************************************/
#include "defines.h"
#include "flashStorageDriver.h"

/* SPM݌̏݊׸ސݒw肷` */
#define WRITE_COMPLETION_PROTECTION

/* SPM߰ޏEEPROMꎞۑw肷` */
#define EEPROM_PARAMETER_BACKUP



#ifndef __AT90Mega128__
  #error "x: flashStorageDriver.hATmega128pɌ`Ă܂"
#endif
#define BOOT_START_ADDRESS 0xF000         // ޲ˑ!!
#define FLASH_PAGE_SIZE  256              // ޲ˑ!!
#define FLASH_PARAMETER_LOCATION 0x000400

#define PARAM_SPACE ( (int) (FLASH_PAGE_SIZE / (DATASIZE + 1.0/8.0) ))  // vf/߰
#define BYTE_WRITTEN_FLAGS ( (int) (PARAM_SPACE+7) / 8)                 // vfɑΉ׸ ޯĐ


__flash const struct _flashParameters{
	DATATYPE parameters[PARAM_SPACE]; // ͎ۂҰ ް܂݂܂B
	unsigned char elementsWrittenFlags[BYTE_WRITTEN_FLAGS]; // ͊eҰʒu׸ ޯĂ܂݂܂B
	unsigned char unused[FLASH_PAGE_SIZE - PARAM_SPACE*DATASIZE - BYTE_WRITTEN_FLAGS]; // ׯ ߰ޓ̋󂫖
	} flashParameters @ FLASH_PARAMETER_LOCATION = {
	
		'A', 'V', 'R', 0x12345678,                         // "Hݒ", ŏ̗vf
	
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,   // ŏI34vf͑S1ɏ
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,   // Ɣ۸/ς
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		0xFF, 0xFF, 0xFF, -1,      0xFF, 0xFF, 0xFF, -1,
		
		0xFE,                                              // 擪׸ ޲(擪vf۸эςݐݒ)
		
		0xFF, 0xFF, 0xFF, 0xFF,                            // c׸ނ͑SĔ۸ѐݒ
		
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF                 // gp޲
	
	};

// @:
//
// 'flashParameters'3̔z̗eʂvZĂB
// 'PARAM_SPACE''BYTE_WRITTEN_FLAGS'ϸۂQƂčł߂lɐ؂̂ĂĂB
// 'parameter'̐擪vfҰɊւ鏉HݒŖĂB
// cS1ޯĕ\(Ⴆ0xFF܂-1)ŖĂB
// 'elementsWrittenFlags'̐擪׸ ޲Ă0xFEɐݒ肵Ă(LSB׸ނ۸эς݂)B
// ׸ ޲Ă̎c0xFFɐݒ肵ĂB
// gpzа ޲(Ⴆ0xFF)ŖĂB
//
// :
//
// EEPROM\ۑ(EEPROM_PARAMETER_BACKUP`ς)ȂA'flashParameters'ȗł܂B
// ɍHݒ'eFlag'޲Ă^(TRUE)̂߂'eParameter'qݒ肵ĂB
// ŉp'flashParameters'̐擪vfׯ ߰ޏ'eParameter'ۑ܂B
// p͏ݑ̒ؾĂNƍlAEEPROM̗\ۑҰgpĉ񕜂s܂B
// AVR޲۸ݸތɂEERPOMeƂ؂ĂB


#ifdef EEPROM_PARAMETER_BACKUP
__eeprom unsigned char eFlag = FALSE;    // EEPROMޯ̧ްL׸
__eeprom DATATYPE eParameter;
#endif


unsigned char parameterIndex = 0;   // ׯ Ұwqϐ(vfwɎgp邱Ƃɒ)


/**************************************************************************
* Function: void flashStorageInit( void )
*
* e:
*      ׯL̊JnްparameterIndexS̕ϐ̍XV
*
**************************************************************************/
#pragma location = "BOOT"
void flashStorageInit( void )
{
  unsigned char temp;
  unsigned char count;
  unsigned char __flash *pFlash;


#ifdef EEPROM_PARAMETER_BACKUP
  /* EEPROM\ۑҰgpׂ */
  if( eFlag == TRUE )   // EEPROMҰLȂA
  {
    parameterIndex = PARAM_SPACE - 1;   // EEPROM̉񕜎w
    flashStorageWrite( eParameter );    // EEPROMҰLҰ
                                        // ُ̎舵ŎĂȂƂɒ
    return;
  }
#endif

  /* ߰ޓ̍ŏIgpҰ */
  pFlash = (unsigned char __flash *) flashParameters.elementsWrittenFlags;

  // 0x00łȂelementsWrittenFlags̐擪޲Č
  while( *pFlash == 0x00 )
  {
    pFlash++;
  };
  
  // ۸эςޯ(=0)ޯ7ޯ0ւČ
  temp = 0x80;
  count = 7;
  do
  {
    if( !(*pFlash & temp) )
    {
      break;
    }
    count--;
    temp >>= 1;    // 1ޯĂ1ޯĈړ
  }while( temp );

  /* ŏ̋vfʒumF */
  parameterIndex = ((pFlash - flashParameters.elementsWrittenFlags) << 3) + count;
}


/**************************************************************************
* Function: unsigned long flashStorageRead( void )
*
* e:
*      ŌׯL֏ꂽްǂŕԂ܂B
*
**************************************************************************/
#pragma location = "BOOT"
DATATYPE flashStorageRead( void )
{
	return flashParameters.parameters[ parameterIndex ];
}


/**************************************************************************
* Function: void flashStorageWrite( DATATYPE flashData )
*
* e:
*      ްzׯLɕۑB
*      LۑKvƂꍇAׯ ߰ޏƂ̊Jn
*
**************************************************************************/
#pragma location = "BOOT"
unsigned char flashStorageWrite( DATATYPE flashData )
{
  unsigned char eepromInterruptSetting;
  unsigned char temp;
  unsigned int tempData;
  unsigned char *tempPtr;
  unsigned char __flash *pFlash;
  unsigned int __flash *pFlashInt;


  /* EEPROM݂słȂƂ̊mF */
  eepromInterruptSetting = EECR & (1<<EERIE);     // EEPROM荞݋ޯĒlꎞۑ
  EECR &= ~(1<<EERIE);                            // EEPROM荞݋֎~
  while(EECR & (1<<EEWE));                        // EEPROM݊܂őҋ@


  /* Ұ ޯ̧ŏʈʒuBAŉʈʒučĊJ */
  if( parameterIndex == PARAM_SPACE - 1 )
  {
#ifdef EEPROM_PARAMETER_BACKUP
    if( !eFlag )                // EEPROMޯ̧ȂA
    {
      eParameter = flashData;   // EEPROMޯ̧ֈꎞۑ
      eFlag = TRUE;             // EEPROMꎞۑҰL׸ސݒ
      while(EECR & (1<<EEWE));  // EEPROM݊ҋ@
    }
#endif


    // Ұ ߰ޏAҰʒuwq
    while( SPMCSR & (1<<SPMEN) );                 // SPMߊҋ@
    _SPM_ERASE( FLASH_PARAMETER_LOCATION );       // ׼ ߰ޏ
    parameterIndex = 0xFF;		     			  // +10ƂȂlҰʒuwq


    /* ߰ޏ */
    pFlashInt = (unsigned int __flash*)FLASH_PARAMETER_LOCATION;
    temp = FLASH_PAGE_SIZE>>1;
    while( SPMCSR & (1<<SPMEN) );                 // SPMߊҋ@
    __DataToR0ByteToSPMCR_SPM( 0, (unsigned char)(1<<RWWSRE)|(1<<SPMEN)); // ׯ RWWċ

    do
    {
      if( *pFlashInt++ != 0xFFFF )                // Ήׯe(ޯĒl=0)ȂA
      {
          EECR |= eepromInterruptSetting;         // EEPROM荞݋ԕA
          return FALSE;                           // sA
      };
    }while(--temp);                               // ߰ޓ܂Ōp
  }


  /* ׯ֐VKް */

  parameterIndex++; // Ұwqis((ŏ̖gp)ۯ)
  pFlash = (unsigned char __flash *) &(flashParameters.parameters[parameterIndex]);  // ׯ޲ ڽ擾

  temp = DATASIZE; // ޲Đv평
  tempPtr = (unsigned char *) &flashData;

  // 擪޲Ď
  if( (unsigned int) pFlash & 0x0001 ) // ڽOdd address?
  {                                        // ڽȂA
    pFlash--; // ꋫE(޲ ڽ)␳
    tempData = (tempPtr[0] << 8) | 0x00FF; // ׯ޲Ăɐ擪޲Ăݒ
    _SPM_FILLTEMP( pFlash, tempData );
    temp--; // ް ޲Čv팸
    pFlash += 2; // ޲ĒPׯʒuwqPʂŐis
    tempPtr++;
  }

  // PSPM߰ވꎞޯ̧o^
  while( temp >= 2 ) // Pʓo^
  {
    tempData = tempPtr[0] | (tempPtr[1] << 8); // 2޲ĂŌꍇ
    _SPM_FILLTEMP( pFlash, tempData ); // SPM߰ވꎞޯ̧o^

    temp -= 2; // ް ޲ČvPʌ
    pFlash += 2; // ޲ĒPׯʒuwqPʂŐis
    tempPtr += 2;
  }

  // ŏI޲Ď
  if( temp > 0 ) // ŏI޲ď
  {
    tempData = 0xFF00 | tempPtr[0]; // ׯꉺ޲ĂɍŏI޲Ăݒ
    SPM_FILLTEMP( pFlash, tempData );
  }


#ifdef WRITE_COMPLETION_PROTECTION
  // WRITE_COMPLETION_PROTECTION`ς݂ȂAŏްA݊ɏ݊׸ނ܂B

  /* SPM߰ވꎞޯ̧e(Ұ)ׯ */
  _SPM_PAGEWRITE( FLASH_PARAMETER_LOCATION );
  while( SPMCSR & (1<<SPMEN) ); // ׯ߰ޏ݊ҋ@
  __DataToR0ByteToSPMCR_SPM( 0, (unsigned char)(1<<RWWSRE)|(1<<SPMEN)); // ׯ RWWċ
#endif

/* ҰvfɑΉ݊׸ ޲Ĉʒu擾 */
  pFlash = (unsigned char __flash *) flashParameters.elementsWrittenFlags; // ׸ސ擪ڽ
  pFlash += parameterIndex>>3; // Ή׸ ޲Ĉʒu擾
  
/* ݊׸ލXVASPM߰ވꎞޯ̧ɐVKްi[ */
  temp = *pFlash;           // Ή݊׸ ޲Čݒl擾
    
  // ݊׸ލXV
  if( temp == 0x00 )  // ݂̏݊׸ ޲ĂSݍς݂ȂA
  {
    pFlash++;     // ׸ ޲Ĉʒuis
    temp = 0xFE;  // Program 1st flag bit to 0
  }
  else                // ݂̏݊׸ ޲ĂɖޯĂŁA
  {
	  temp <<= 1; // ޯ(=1)ݍς(=0)ɐݒ
  }

  // ݊׸ނSPM߰ވꎞޯ̧ɐݒ
  if( (unsigned int)pFlash & 0x0001 )         // ڽȂ޲ĂƂČč
  {
    pFlash--;
    tempData = (temp<<8) | 0x00FF;
  }
  else                                        // ڽȂ牺޲ĂƂČč
  {
    tempData = 0xFF00 | temp;
  }

  _SPM_FILLTEMP( pFlash, tempData );          // Ή݊׸ ޲ĂSPM߰ވꎞޯ̧o^


  /* ׯSPMꎞޯ̧e(݊׸) */
  _SPM_PAGEWRITE( FLASH_PARAMETER_LOCATION );
  while( SPMCSR & (1<<SPMEN) ); // ׯ߰ޏ݊ҋ@
  __DataToR0ByteToSPMCR_SPM( 0, (unsigned char)(1<<RWWSRE)|(1<<SPMEN)); // ׯ RWWċ

#ifdef EEPROM_PARAMETER_BACKUP
    eFlag = FALSE;             // EEPROMꎞۑҰL׸މ
#endif

  EECR |= eepromInterruptSetting;                            // EEPROM荞݋ԕA
  
  return TRUE;                 // A
}
